package Site::Page;
# LICENSE
#
# Copyright (c) 2001 Steve Slaven. All rights reserved.
#
# This program is free software  and is provided "as is" without
# express or implied warranty. You can redistribute it and/or
# modify it under the same terms as Perl itself.
#

use strict;
use vars qw( %AUTOFIELDS @ISA $OPTS );

use PObject;
@ISA = qw( PObject );

use CGI;
#require( "Site/cookie.lib" );

use DB_File;
use URI::Escape;
use HTML::Entities ();

%AUTOFIELDS = ( TITLE => "Untitled",
			SUBTITLE => undef,
			SESSION => undef,
			OPTIONS => undef,
			COOKIES => undef,
			USESESSIONS => 0,
			SESSIONID => undef,
			SESSIONFILE => '/tmp/default_session.%s.db',

			INITIALIZED => undef );

my( $q );
#my( $CMD, $A, $B );

# Uses CGI now
$q = new CGI;
$OPTS = $q -> Vars();

# This will automagically slurp in the web data
#if( $main::ENV{ REQUEST_METHOD } eq "POST" )
#{
#    read STDIN, $CMD, $main::ENV{ CONTENT_LENGTH };
#}
#else
#{
#    $CMD = $main::ENV{ QUERY_STRING };
#}
# Fix spaces
#$CMD =~ s/\+/ /g;
#for ( split( /&/, $CMD ) )
#{
#    s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
#
#    ( $A, $B ) = $_ =~ /^(.*?)=(.*)/s;
#
#    # All keys are lowercase
#    $OPTS{ lc( $A ) } = $B;
#}

sub import
{
	shift();

	# Allow some options to change
}

sub OBJ_NEW
{
	my $self = shift;
	$self -> initialize();
	return( $self );
}

# Handles std look and feel of pages
sub initialize
{
	# Look up saved state, if any
	my $Self = shift;

	my %Session;
	my $SessionName;
	my $c;

	#GetCookies();

	if( $Self -> UseSessions() )
	{
		if( $q -> cookie( 'sid' ) )
		{
			$SessionName = $Self -> _GenerateSessionName( $q -> cookie( 'sid' ) );
			$Self -> SessionID( $q -> cookie( 'sid' ) );
		}
		else
		{
			$Self -> SessionID( $$ . time() );
			#( 'sid', $Self -> SessionID() );
 			$c = $q -> cookie( -name=>'sid',
                                  		-value=>$Self -> SessionID() );
                                    		#-expires=>'+1h',
                                    		#-path=>'/cgi-bin/database',
                                    		#-domain=>'.capricorn.org',
                                    		#-secure=>1);
           		print $q -> header( -cookie => $c );

			$SessionName = $Self -> _GenerateSessionName( $$ . time() );
		}

		$Self -> _dmesg( "Tying to session: $SessionName", 3 );
		tie %Session, 'DB_File', $SessionName;

		# Put in some standard infos
		$Session{ lastaccessed } = time();

		$Session{ ip } = $main::ENV{ "REMOTE_ADDR" };

		$Session{ lasturi } = $Session{ thisuri };
		$Session{ thisuri } = $main::ENV{ "REQUEST_URI" };
		if( $Session{ lasturi } ne $Session{ thisuri } )
		{
			$Session{ lastdistincturi } = $Session{ lasturi };
		}

		$Self -> { SESSION } = \%Session;
	}

	# Save all the hashes
	$Self -> { OPTIONS } = $OPTS;
	#$Self -> { COOKIES } = \%Site::Page::Cookies;
}

sub start
{
	my $Self = shift;

	my $Title = $Self -> title();
	my $Secondary = $Self -> subtitle() || "No sub title";
  
    print <<EOF;
Content-type: text/html


<HTML>
  <HEAD>
    <TITLE>$Title - $Secondary</TITLE>
  </HEAD>
  
  <BODY>

EOF
}


sub end
{
    print <<EOF;
    </BODY>

</HTML>
EOF

}

sub set_cookie
{
	my $Self = shift;
	my %Hash = @_;
	my $c;

	for( keys( %Hash ) )
	{
                        $c = $q -> cookie( -name=>$_,
                                                -value=>$Hash{$_} );
                                                #-expires=>'+1h',
                                                #-path=>'/cgi-bin/database',
                                                #-domain=>'.capricorn.org',
                                                #-secure=>1);
                        print $q -> header( -cookie => $c );
	}
}

sub redirect
{
	my $Self = shift;

	print "Location: " . shift();
	print "\n\n";
	exit( 0 );
}

sub _GenerateSessionName
{
	my $Self = shift;

	my $SessionID = shift;

	return( sprintf( $Self -> SessionFile(), $SessionID ) );
}

sub escape_uri
{
	my $Self = shift;
	my $Text = uri_escape( shift() );
	# Doesn't escape out &?
	$Text =~ s/&/\%26/g;
	return( $Text );
}

sub encode_entities
{
	my $Self = shift;

	return( HTML::Entities::encode( shift() ) );
}

sub decode_entities
{
	my $Self = shift;
	return( HTML::Entities::decode( shift() ) );
}

# All these are legacy support functions
#sub Initialize { return( shift() -> initialize( @_ ) ) }

1;
 
